local tukuiskin = true -- set to false to override Tukui-specific skin, only applies to Tukui users.
local maxbags = 32 -- change if you have a bag with more than 32 slots

-- [[ FreeUI functions ]]

local classcolors = {
	["HUNTER"] = { r = 0.58, g = 0.86, b = 0.49 },
	["WARLOCK"] = { r = 0.6, g = 0.47, b = 0.85 },
	["PALADIN"] = { r = 1, g = 0.22, b = 0.52 },
	["PRIEST"] = { r = 0.8, g = 0.87, b = .9 },
	["MAGE"] = { r = 0, g = 0.76, b = 1 },
	["ROGUE"] = { r = 1, g = 0.91, b = 0.2 },
	["DRUID"] = { r = 1, g = 0.49, b = 0.04 },
	["SHAMAN"] = { r = 0, g = 0.6, b = 0.6 };
	["WARRIOR"] = { r = 0.9, g = 0.65, b = 0.45 },
	["DEATHKNIGHT"] = { r = 0.77, g = 0.12 , b = 0.23 },
}

Aurora = {
	["backdrop"] = "Interface\\ChatFrame\\ChatFrameBackground",
	["glow"] = "Interface\\AddOns\\Aurora\\glow",
}

Aurora.dummy = function() end

Aurora.CreateBD = function(f, a)
	f:SetBackdrop({
		bgFile = Aurora.backdrop, 
		edgeFile = Aurora.backdrop, 
		edgeSize = 1, 
	})
	f:SetBackdropColor(0, 0, 0, a or .5)
	f:SetBackdropBorderColor(0, 0, 0)
end

Aurora.CreateSD = function(parent, size, r, g, b, alpha, offset)
	local sd = CreateFrame("Frame", nil, parent)
	sd.size = size or 5
	sd.offset = offset or 0
	sd:SetBackdrop({
		edgeFile = Aurora.glow,
		edgeSize = sd.size,
	})
	sd:SetPoint("TOPLEFT", parent, -sd.size - 1 - sd.offset, sd.size + 1 + sd.offset)
	sd:SetPoint("BOTTOMRIGHT", parent, sd.size + 1 + sd.offset, -sd.size - 1 - sd.offset)
	sd:SetBackdropBorderColor(r or 0, g or 0, b or 0)
	sd:SetAlpha(alpha or 1)
end

Aurora.CreatePulse = function(frame, speed, mult, alpha) -- pulse function originally by nightcracker
	frame.speed = speed or .05
	frame.mult = mult or 1
	frame.alpha = alpha or 1
	frame.tslu = 0 -- time since last update
	frame:SetScript("OnUpdate", function(self, elapsed)
		self.tslu = self.tslu + elapsed
		if self.tslu > self.speed then
			self.tslu = 0
			self:SetAlpha(self.alpha)
		end
		self.alpha = self.alpha - elapsed*self.mult
		if self.alpha < 0 and self.mult > 0 then
			self.mult = self.mult*-1
			self.alpha = 0
		elseif self.alpha > 1 and self.mult < 0 then
			self.mult = self.mult*-1
		end
	end)
end

Aurora.CreateTab = function(f)
	local sd = CreateFrame("Frame", nil, f)
	sd:SetBackdrop({
		bgFile = Aurora.backdrop,
		edgeFile = Aurora.glow,
		edgeSize = 5,
		insets = { left = 5, right = 5, top = 5, bottom = 5 },
	})
	sd:SetPoint("TOPLEFT", 6, -2)
	sd:SetPoint("BOTTOMRIGHT", -6, 0)
	sd:SetBackdropColor(0, 0, 0, .5)
	sd:SetBackdropBorderColor(0, 0, 0)
	sd:SetFrameStrata("LOW")
end

if IsAddOnLoaded("Tukui") and tukuiskin == true then
	Aurora.CreateBD = function(f)
		f:SetBackdrop({
			bgFile = Aurora.backdrop,
			edgeFile = Aurora.backdrop,
			tile = false, tileSize = 0, edgeSize = 1, 
	 		insets = { left = -1, right = -1, top = -1, bottom = -1}
		})
		f:SetBackdropColor(unpack(TukuiCF["media"].backdropcolor))
		f:SetBackdropBorderColor(unpack(TukuiCF["media"].bordercolor))
	end

	Aurora.CreateSD = function() end

	Aurora.CreateTab = function(f)
		local sd = CreateFrame("Frame", nil, f)
		sd:SetBackdrop({
			bgFile = Aurora.backdrop,
			edgeFile = Aurora.backdrop,
			tile = false, tileSize = 0, edgeSize = 1, 
	 		insets = { left = -1, right = -1, top = -1, bottom = -1}
		})
		sd:SetPoint("TOPLEFT", 6, -2)
		sd:SetPoint("BOTTOMRIGHT", -6, 0)
		sd:SetBackdropColor(unpack(TukuiCF["media"].backdropcolor))
		sd:SetBackdropBorderColor(unpack(TukuiCF["media"].bordercolor))
		sd:SetFrameStrata("LOW")
	end
end

-- [[ Addon core ]]

local Skin = CreateFrame("Frame", nil, UIParent)
local _, class = UnitClass("player")
local c
if CUSTOM_CLASS_COLORS then 
	c = CUSTOM_CLASS_COLORS[class]
elseif IsAddOnLoaded("Tukui") and tukuiskin == true then
	c = RAID_CLASS_COLORS[class]
else
	c = classcolors[class]
end

Aurora.Reskin = function(f)
	local glow = CreateFrame("Frame", nil, f)
	glow:SetBackdrop({
		edgeFile = Aurora.glow,
		edgeSize = 5,
	})
	glow:SetPoint("TOPLEFT", f, -6, 6)
	glow:SetPoint("BOTTOMRIGHT", f, 6, -6)
	glow:SetBackdropBorderColor(c.r, c.g, c.b)
	glow:SetAlpha(0)

	f:SetNormalTexture("")
	f:SetHighlightTexture("")
	f:SetPushedTexture("")
	f:SetDisabledTexture("")

	Aurora.CreateBD(f, .25)

	f:HookScript("OnEnter", function(self) self:SetBackdropBorderColor(c.r, c.g, c.b) self:SetBackdropColor(c.r, c.g, c.b, .1) Aurora.CreatePulse(glow) end)
 	f:HookScript("OnLeave", function(self) self:SetBackdropBorderColor(0, 0, 0) self:SetBackdropColor(0, 0, 0, .25) glow:SetScript("OnUpdate", nil) glow:SetAlpha(0) end)
end

if IsAddOnLoaded("Tukui") and tukuiskin == true then
	Aurora.Reskin = function(f)
		f:SetNormalTexture("")
		f:SetHighlightTexture("")
		f:SetPushedTexture("")
		f:SetDisabledTexture("")

		Aurora.CreateBD(f)

		f:HookScript("OnEnter", function(self) self:SetBackdropBorderColor(c.r, c.g, c.b) self:SetBackdropColor(c.r, c.g, c.b, .15) end)
	 	f:HookScript("OnLeave", function(self) self:SetBackdropBorderColor(unpack(TukuiCF["media"].bordercolor)) self:SetBackdropColor(unpack(TukuiCF["media"].backdropcolor)) end)
	end
end

Skin:RegisterEvent("ADDON_LOADED")
Skin:SetScript("OnEvent", function(self, event, addon)	
	if addon == "Aurora" then

		-- [[ Headers ]]

		local header = {"GameMenuFrame", "InterfaceOptionsFrame", "AudioOptionsFrame", "VideoOptionsFrame", "ChatConfigFrame", "ColorPickerFrame"}
		for i = 1, getn(header) do
		local title = _G[header[i].."Header"]
			if title then
				title:SetTexture("")
				title:ClearAllPoints()
				if title == _G["GameMenuFrameHeader"] then
					title:SetPoint("TOP", GameMenuFrame, 0, 7)
				else
					title:SetPoint("TOP", header[i], 0, 0)
				end
			end
		end

		-- [[ Simple backdrops ]]

		local skins = {"AutoCompleteBox", "BNToastFrame", "TicketStatusFrameButton", "DropDownList1Backdrop", "DropDownList2Backdrop", "DropDownList1MenuBackdrop", "DropDownList2MenuBackdrop", "LFDSearchStatus", "FriendsTooltip", "GhostFrame", "GhostFrameContentsFrame", "DropDownList1MenuBackdrop", "DropDownList2MenuBackdrop", "DropDownList1Backdrop", "DropDownList2Backdrop"}

		for i = 1, getn(skins) do
			Aurora.CreateBD(_G[skins[i]])
		end

		local shadowskins = {"StaticPopup1", "StaticPopup2", "GameMenuFrame", "InterfaceOptionsFrame", "VideoOptionsFrame", "AudioOptionsFrame", "LFDDungeonReadyStatus", "ChatConfigFrame", "AutoCompleteBox", "SpellBookFrame", "CharacterFrame", "PVPFrame", "GearManagerDialog", "WorldStateScoreFrame", "GearManagerDialogPopup", "StackSplitFrame", "AddFriendFrame", "FriendsFriendsFrame", "ColorPickerFrame", "ReadyCheckFrame", "PetStableFrame", "LFDDungeonReadyDialog", "ReputationDetailFrame", "LFDRoleCheckPopup"}

		for i = 1, getn(shadowskins) do
			Aurora.CreateBD(_G[shadowskins[i]])
			Aurora.CreateSD(_G[shadowskins[i]])
		end

		local simplebds = {"SpellBookCompanionModelFrame", "PrimaryProfession1", "PrimaryProfession2", "SecondaryProfession1", "SecondaryProfession2", "SecondaryProfession3", "SecondaryProfession4", "ChatConfigCategoryFrame", "ChatConfigBackgroundFrame", "ChatConfigChatSettingsLeft", "ChatConfigChatSettingsClassColorLegend", "ChatConfigChannelSettingsLeft", "ChatConfigChannelSettingsClassColorLegend", "FriendsFriendsList"}
		for i = 1, getn(simplebds) do
			local simplebd = _G[simplebds[i]]
			if simplebd then Aurora.CreateBD(simplebd, .25) end
		end

		for i = 1, 5 do
			local a1, p, a2, x, y = _G["SpellBookSkillLineTab"..i]:GetPoint()
			local bg = CreateFrame("Frame", nil, _G["SpellBookSkillLineTab"..i])
			bg:SetPoint("TOPLEFT", -1, 1)
			bg:SetPoint("BOTTOMRIGHT", 1, -1)
			bg:SetFrameLevel(_G["SpellBookSkillLineTab"..i]:GetFrameLevel()-1)
			if IsAddOnLoaded("Tukui") and tukuiskin == true then
				_G["SpellBookSkillLineTab"..i]:SetPoint(a1, p, a2, x + 5, y)
				bg:SetPoint("TOPLEFT", -2, 2)
				bg:SetPoint("BOTTOMRIGHT", 2, -2)
				Aurora.CreateBD(bg)
			else
				_G["SpellBookSkillLineTab"..i]:SetPoint(a1, p, a2, x + 11, y)
				Aurora.CreateSD(_G["SpellBookSkillLineTab"..i], 5, 0, 0, 0, 1, 1)
				Aurora.CreateBD(bg, 1)
			end
			select(3, _G["SpellBookSkillLineTab"..i]:GetRegions()):SetTexCoord(.08, .92, .08, .92)
			select(4, _G["SpellBookSkillLineTab"..i]:GetRegions()):SetTexCoord(.08, .92, .08, .92)
		end

		-- [[ Backdrop frames ]]

		FriendsBD = CreateFrame("Frame", nil, FriendsFrame)
		FriendsBD:SetPoint("TOPLEFT", 10, -30)
		FriendsBD:SetPoint("BOTTOMRIGHT", -34, 76)

		QuestBD = CreateFrame("Frame", nil, QuestLogFrame)
		QuestBD:SetPoint("TOPLEFT", 4, -9)
		QuestBD:SetPoint("BOTTOMRIGHT", -2, 6)
		QuestBD:SetFrameLevel(QuestLogFrame:GetFrameLevel()-1)

		QFBD = CreateFrame("Frame", nil, QuestFrame)
		QFBD:SetPoint("TOPLEFT", 4, -15)
		QFBD:SetPoint("BOTTOMRIGHT", -26, 64)
		QFBD:SetFrameLevel(QuestFrame:GetFrameLevel()-1)

		QDBD = CreateFrame("Frame", nil, QuestLogDetailFrame)
		QDBD:SetPoint("TOPLEFT", 4, -9)
		QDBD:SetPoint("BOTTOMRIGHT", 0, 0)
		QDBD:SetFrameLevel(QuestLogDetailFrame:GetFrameLevel()-1)

		GossipBD = CreateFrame("Frame", nil, GossipFrame)
		GossipBD:SetPoint("TOPLEFT", 4, -15)
		GossipBD:SetPoint("BOTTOMRIGHT", -26, 64)

		LFDBD = CreateFrame("Frame", nil, LFDParentFrame)
		LFDBD:SetPoint("TOPLEFT", 10, -10)
		LFDBD:SetPoint("BOTTOMRIGHT", 0, 0)

		LFRBD = CreateFrame("Frame", nil, LFRParentFrame)
		LFRBD:SetPoint("TOPLEFT", 10, -10)
		LFRBD:SetPoint("BOTTOMRIGHT", 0, 4)

		MerchBD = CreateFrame("Frame", nil, MerchantFrame)
		MerchBD:SetPoint("TOPLEFT", 10, -10)
		MerchBD:SetPoint("BOTTOMRIGHT", -34, 61)
		MerchBD:SetFrameLevel(MerchantFrame:GetFrameLevel()-1)

		MailBD = CreateFrame("Frame", nil, MailFrame)
		MailBD:SetPoint("TOPLEFT", 10, -12)
		MailBD:SetPoint("BOTTOMRIGHT", -34, 73)

		OMailBD = CreateFrame("Frame", nil, OpenMailFrame)
		OMailBD:SetPoint("TOPLEFT", 10, -12)
		OMailBD:SetPoint("BOTTOMRIGHT", -34, 73)
		OMailBD:SetFrameLevel(OpenMailFrame:GetFrameLevel()-1)

		DressBD = CreateFrame("Frame", nil, DressUpFrame)
		DressBD:SetPoint("TOPLEFT", 10, -10)
		DressBD:SetPoint("BOTTOMRIGHT", -30, 72)
		DressBD:SetFrameLevel(DressUpFrame:GetFrameLevel()-1)

		TaxiBD = CreateFrame("Frame", nil, TaxiFrame)
		TaxiBD:SetPoint("TOPLEFT", 3, -23)
		TaxiBD:SetPoint("BOTTOMRIGHT", -5, 3)
		TaxiBD:SetFrameStrata("LOW")
		TaxiBD:SetFrameLevel(TaxiFrame:GetFrameLevel()-1)

		NPCBD = CreateFrame("Frame", nil, QuestNPCModel)
		NPCBD:SetPoint("TOPLEFT", 9, -6)
		NPCBD:SetPoint("BOTTOMRIGHT", 4, -66)
		NPCBD:SetFrameLevel(QuestNPCModel:GetFrameLevel()-1)

		TradeBD = CreateFrame("Frame", nil, TradeFrame)
		TradeBD:SetPoint("TOPLEFT", 10, -12)
		TradeBD:SetPoint("BOTTOMRIGHT", -30, 52)
		TradeBD:SetFrameLevel(TradeFrame:GetFrameLevel()-1)

		ItemBD = CreateFrame("Frame", nil, ItemTextFrame)
		ItemBD:SetPoint("TOPLEFT", 16, -8)
		ItemBD:SetPoint("BOTTOMRIGHT", -28, 62)
		ItemBD:SetFrameLevel(ItemTextFrame:GetFrameLevel()-1)

		TabardBD = CreateFrame("Frame", nil, TabardFrame)
		TabardBD:SetPoint("TOPLEFT", 16, -8)
		TabardBD:SetPoint("BOTTOMRIGHT", -28, 76)
		TabardBD:SetFrameLevel(TabardFrame:GetFrameLevel()-1)

		local FrameBDs = {"FriendsBD", "QuestBD", "QFBD", "QDBD", "GossipBD", "LFDBD", "LFRBD", "MerchBD", "MailBD", "OMailBD", "DressBD", "TaxiBD", "TradeBD", "ItemBD", "TabardBD"}
		for i = 1, getn(FrameBDs) do
			FrameBD = _G[FrameBDs[i]]
			if FrameBD then
				Aurora.CreateBD(FrameBD)
				Aurora.CreateSD(FrameBD)
			end
		end

		Aurora.CreateBD(NPCBD)

		if class == "HUNTER" or class == "MAGE" or class == "DEATHKNIGHT" or class == "WARLOCK" then
			if class == "HUNTER" then
				for i = 1, 10 do
					local bd = CreateFrame("Frame", nil, _G["PetStableStabledPet"..i])
					bd:SetPoint("TOPLEFT", -1, 1)
					bd:SetPoint("BOTTOMRIGHT", 1, -1)
					Aurora.CreateBD(bd)
					bd:SetBackdropColor(0, 0, 0, 0)
					_G["PetStableStabledPet"..i]:SetNormalTexture("")
					select(1, _G["PetStableStabledPet"..i]:GetRegions()):SetTexCoord(.08, .92, .08, .92)
				end
			end

			PetModelFrameShadowOverlay:Hide()
			select(1, PetPaperDollFrameExpBar:GetRegions()):Hide()
			select(2, PetPaperDollFrameExpBar:GetRegions()):Hide()

			local bbg = CreateFrame("Frame", nil, PetPaperDollFrameExpBar)
			bbg:SetPoint("TOPLEFT", -1, 1)
			bbg:SetPoint("BOTTOMRIGHT", 1, -1)
			bbg:SetFrameLevel(PetPaperDollFrameExpBar:GetFrameLevel()-1)
			Aurora.CreateBD(bbg, .25)
		end

		-- [[ Hide regions ]]

		select(3, CharacterFrame:GetRegions()):Hide()
		for i = 1, 5 do
			select(i, CharacterModelFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			select(i, QuestLogFrame:GetRegions()):Hide()
		end
		select(1, QuestLogDetailFrame:GetRegions()):Hide()
		select(1, QuestFrame:GetRegions()):Hide()
		select(1, GossipFrame:GetRegions()):Hide()
		for i = 1, 6 do
			for j = 1, 3 do
				select(i, _G["FriendsTabHeaderTab"..j]:GetRegions()):Hide()
				select(i, _G["FriendsTabHeaderTab"..j]:GetRegions()).Show = Aurora.dummy
			end
		end
		select(6, FriendsFrame:GetRegions()):Hide()
		select(3, SpellBookFrame:GetRegions()):Hide()
		SpellBookCompanionModelFrameShadowOverlay:Hide()
		select(3, PVPFrame:GetRegions()):Hide()
		select(1, LFRParentFrame:GetRegions()):Hide()
		for i = 1, 5 do
			select(i, MailFrame:GetRegions()):Hide()
		end
		select(1, OpenMailFrame:GetRegions()):Hide()
		select(12, OpenMailFrame:GetRegions()):Hide()
		select(13, OpenMailFrame:GetRegions()):Hide()
		for i = 4, 7 do
			select(i, SendMailFrame:GetRegions()):Hide()
		end
		select(1, MerchantFrame:GetRegions()):Hide()
		select(1, DressUpFrame:GetRegions()):Hide()
		select(2, DressUpFrame:GetRegions()):Hide()
		for i = 8, 11 do
			select(i, DressUpFrame:GetRegions()):Hide()
		end
		select(6, TaxiFrame:GetRegions()):Hide()
		select(1, TradeFrame:GetRegions()):Hide()
		select(2, TradeFrame:GetRegions()):Hide()
		for i = 1, 4 do
			select(i, GearManagerDialogPopup:GetRegions()):Hide()
		end
		select(1, StackSplitFrame:GetRegions()):Hide()
		select(1, ItemTextFrame:GetRegions()):Hide()
		select(3, ItemTextScrollFrame:GetRegions()):Hide()
		select(3, PetStableFrame:GetRegions()):Hide()
		select(4, ReputationDetailFrame:GetRegions()):Hide()
		select(5, ReputationDetailFrame:GetRegions()):Hide()
		select(2, QuestNPCModel:GetRegions()):Hide()
		select(1, TabardFrame:GetRegions()):Hide()
		BNToastFrameCloseButton:SetAlpha(0)
		PetStableModelShadow:Hide()
		LFDParentFramePortrait:Hide()

		local slots = {
			"Head", "Neck", "Shoulder", "Shirt", "Chest", "Waist", "Legs", "Feet", "Wrist",
			"Hands", "Finger0", "Finger1", "Trinket0", "Trinket1", "Back", "MainHand",
			"SecondaryHand", "Ranged", "Tabard",
		}

		for i = 1, getn(slots) do
			_G["Character"..slots[i].."Slot"]:SetNormalTexture("")
			select(1, _G["Character"..slots[i].."Slot"]:GetRegions()):SetTexCoord(.08, .92, .08, .92)
			local bd = CreateFrame("Frame", nil, _G["Character"..slots[i].."Slot"])
			bd:SetPoint("TOPLEFT", -1, 1)
			bd:SetPoint("BOTTOMRIGHT", 1, -1)
			Aurora.CreateBD(bd)
			bd:SetBackdropColor(0, 0, 0, 0)
		end

		_G["ReadyCheckFrame"]:HookScript("OnShow", function(self) if UnitIsUnit("player", self.initiator) then self:Hide() end end)

		-- [[ Loot ]]

		if not IsAddOnLoaded("Butsu") and not IsAddOnLoaded("XLoot") and not IsAddOnLoaded("Tukui") then
			select(1, LootFrame:GetRegions()):Hide()
			select(3, LootFrame:GetRegions()):Hide()
			LootCloseButton:Hide()

			-- LootFrame:SetWidth(190)
			LootFrame:SetHeight(.001)
			LootFrame:SetHeight(.001)

			local reskinned = 1

			LootFrame:HookScript("OnShow", function()
				for i = reskinned, GetNumLootItems() do
					local bu = _G["LootButton"..i]
					local qu = _G["LootButton"..i.."IconQuestTexture"]
					if not bu then return end
					local _, _, _, _, _, _, _, bg = bu:GetRegions()

					-- LootFrame:SetHeight(100 + 37 * i)

					local LootBD = CreateFrame("Frame", nil, bu)
					LootBD:SetFrameLevel(LootFrame:GetFrameLevel()-1)
					LootBD:SetPoint("TOPLEFT", 38, -1)
					LootBD:SetPoint("BOTTOMRIGHT", bu, 170, 1)

					Aurora.CreateBD(LootBD)
					Aurora.CreateBD(bu)

					bu:SetNormalTexture("")
					bu:GetRegions():SetTexCoord(.08, .92, .08, .92)
					bu:GetRegions():SetPoint("TOPLEFT", 1, -1)
					bu:GetRegions():SetPoint("BOTTOMRIGHT", -1, 1)
					bg:Hide()
					qu:SetTexture("Interface\\AddOns\\Aurora\\quest")
					qu:SetVertexColor(1, 0, 0)
					qu:SetTexCoord(.03, .97, .03, .995)
					qu.SetTexture = Aurora.dummy

					reskinned = i + 1
				end
			end)
		end

		-- [[ Bags ]]

		if not IsAddOnLoaded("Baggins") and not IsAddOnLoaded("Stuffing") and not IsAddOnLoaded("Combuctor") and not IsAddOnLoaded("cargBags") and not IsAddOnLoaded("ArkInventory") and not IsAddOnLoaded("Tukui") then
			for i = 1, 5 do
				local con = _G["ContainerFrame"..i]
				for j = 1, 7 do
					select(j, con:GetRegions()):Hide()
					select(j, con:GetRegions()).Show = Aurora.dummy
				end
				for k = 1, maxbags do
					_G["ContainerFrame"..i.."Item"..k]:SetNormalTexture("")
						_G["ContainerFrame"..i.."Item"..k.."IconTexture"]:SetTexCoord(.08, .92, .08, .92)
						_G["ContainerFrame"..i.."Item"..k.."IconQuestTexture"]:SetTexture("Interface\\AddOns\\FreeBags\\border")
						_G["ContainerFrame"..i.."Item"..k.."IconQuestTexture"]:SetVertexColor(1, 0, 0)
						_G["ContainerFrame"..i.."Item"..k.."IconQuestTexture"]:SetTexCoord(0.05, .955, 0.05, .965)
						_G["ContainerFrame"..i.."Item"..k.."IconQuestTexture"].SetTexture = Aurora.dummy
						local bd = CreateFrame("Frame", nil, _G["ContainerFrame"..i.."Item"..k])
						bd:SetPoint("TOPLEFT", -1, 1)
						bd:SetPoint("BOTTOMRIGHT", 1, -1)
						Aurora.CreateBD(bd, 0)
				end

				local f = CreateFrame("Frame", nil, con)
				f:SetPoint("TOPLEFT", 8, -4)
				f:SetPoint("BOTTOMRIGHT", -4, 3)
				f:SetFrameLevel(con:GetFrameLevel()-1)
				Aurora.CreateBD(f)
			end
		end

		-- [[ Tooltips ]]

		if not IsAddOnLoaded("CowTip") and not IsAddOnLoaded("TipTac") and not IsAddOnLoaded("FreebTip") and not IsAddOnLoaded("lolTip") and not IsAddOnLoaded("Tukui") then
			do
				local tooltips = {
					"GameTooltip",
					"ItemRefTooltip",
					"ShoppingTooltip1",
					"ShoppingTooltip2",
					"ShoppingTooltip3",
					"WorldMapTooltip",
					"ChatMenu",
					"EmoteMenu",
					"LanguageMenu",
					"VoiceMacroMenu",
				}

				for i = 1, #tooltips do
					local t = _G[tooltips[i]]
					t:SetBackdrop(nil)
					local bg = CreateFrame("Frame", nil, t)
					bg:SetBackdrop({ 
						bgFile = Aurora.backdrop, 
						edgeFile = Aurora.backdrop,
						edgeSize = 1,
					})
					bg:SetBackdropColor(0, 0, 0, .6)
					bg:SetBackdropBorderColor(0, 0, 0)
					bg:SetWidth(t:GetWidth())
					bg:SetHeight(t:GetHeight())
					bg:SetPoint("TOPLEFT")
					bg:SetPoint("BOTTOMRIGHT")
					bg:SetFrameStrata("DIALOG")
				end
			end

			local sb = _G["GameTooltipStatusBar"]
			sb:SetHeight(3)
			sb:ClearAllPoints()
			sb:SetPoint("BOTTOMLEFT", GameTooltip, "BOTTOMLEFT", 1, 1)
			sb:SetPoint("BOTTOMRIGHT", GameTooltip, "BOTTOMRIGHT", -1, 1)
		end

		-- [[ Text colour functions ]]

		NORMAL_QUEST_DISPLAY = "|cffffffff%s|r"
		TRIVIAL_QUEST_DISPLAY = "|cffffffff%s (low level)|r"

		local newquestcolor = function(template, parentFrame, acceptButton, material)
			QuestInfoTitleHeader:SetTextColor(1, 1, 1);
			QuestInfoDescriptionHeader:SetTextColor(1, 1, 1);
			QuestInfoObjectivesHeader:SetTextColor(1, 1, 1);
			QuestInfoRewardsHeader:SetTextColor(1, 1, 1);
			-- other text
			QuestInfoDescriptionText:SetTextColor(1, 1, 1);
			QuestInfoObjectivesText:SetTextColor(1, 1, 1);
			QuestInfoGroupSize:SetTextColor(1, 1, 1);
			QuestInfoRewardText:SetTextColor(1, 1, 1);
			-- reward frame text
			QuestInfoItemChooseText:SetTextColor(1, 1, 1);
			QuestInfoItemReceiveText:SetTextColor(1, 1, 1);
			QuestInfoSpellLearnText:SetTextColor(1, 1, 1);		
			QuestInfoXPFrameReceiveText:SetTextColor(1, 1, 1);

			local numObjectives = GetNumQuestLeaderBoards();
			local objective;
			local text, type, finished;
			local numVisibleObjectives = 0;
			for i = 1, numObjectives do
				text, type, finished = GetQuestLogLeaderBoard(i);
				if (type ~= "spell") then
					numVisibleObjectives = numVisibleObjectives+1;
					objective = _G["QuestInfoObjective"..numVisibleObjectives];
					objective:SetTextColor(1, 1, 1);
				end
			end
		end

		local newgossipcolor = function()
			GossipGreetingText:SetTextColor(1, 1, 1)
		end
		function QuestFrame_SetTitleTextColor(fontString)
			fontString:SetTextColor(1, 1, 1)
		end

		function QuestFrame_SetTextColor(fontString)
			fontString:SetTextColor(1, 1, 1);
		end

		function GossipFrameOptionsUpdate(...)
			local titleButton;
			local titleIndex = 1;
			local titleButtonIcon;
			for i=1, select("#", ...), 2 do
				if ( GossipFrame.buttonIndex > NUMGOSSIPBUTTONS ) then
					message("This NPC has too many quests and/or gossip options.");
				end
				titleButton = _G["GossipTitleButton" .. GossipFrame.buttonIndex];
				titleButton:SetFormattedText("|cffffffff%s|r", select(i, ...));
				GossipResize(titleButton);
				titleButton:SetID(titleIndex);
				titleButton.type="Gossip";
				titleButtonIcon = _G[titleButton:GetName() .. "GossipIcon"];
				titleButtonIcon:SetTexture("Interface\\GossipFrame\\" .. select(i+1, ...) .. "GossipIcon");
				titleButtonIcon:SetVertexColor(1, 1, 1, 1);
				GossipFrame.buttonIndex = GossipFrame.buttonIndex + 1;
				titleIndex = titleIndex + 1;
				titleButton:Show();
			end
		end

		local newspellbookcolor = function(self)
			local slot, slotType = SpellBook_GetSpellBookSlot(self);
			local name = self:GetName();
			-- local spellString = _G[name.."SpellName"];
			local subSpellString = _G[name.."SubSpellName"]

			-- spellString:SetTextColor(1, 1, 1)
			subSpellString:SetTextColor(1, 1, 1)
			if slotType == "FUTURESPELL" then
				local level = GetSpellAvailableLevel(slot, SpellBookFrame.bookType)
				if (level and level > UnitLevel("player")) then
					self.RequiredLevelString:SetTextColor(.7, .7, .7)
					self.SpellName:SetTextColor(.7, .7, .7)
					subSpellString:SetTextColor(.7, .7, .7)
				end
			end
		end

		local newprofcolor = function(frame, index)
			if index then
				local rank = GetProfessionInfo(index)
				-- frame.rank:SetTextColor(1, 1, 1)
				frame.professionName:SetTextColor(1, 1, 1)
			else
				frame.missingText:SetTextColor(1, 1, 1)
				frame.missingHeader:SetTextColor(1, 1, 1)
			end
		end

		local newprofbuttoncolor = function(self)
			self.spellString:SetTextColor(1, 1, 1);	
			self.subSpellString:SetTextColor(1, 1, 1)
		end	
	
		ItemTextFrame:HookScript("OnEvent", function(self, event, ...)
			if event == "ITEM_TEXT_BEGIN" then
				ItemTextTitleText:SetText(ItemTextGetItem())
				ItemTextScrollFrame:Hide()
				ItemTextCurrentPage:Hide()
				ItemTextStatusBar:Hide()
				ItemTextPrevPageButton:Hide()
				ItemTextNextPageButton:Hide()
				ItemTextPageText:SetTextColor(1, 1, 1)
				return
			end
		end)

		function PaperDollFrame_SetLevel()
			local primaryTalentTree = GetPrimaryTalentTree()
			local classDisplayName, class = UnitClass("player")
			local classColor = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or classcolors[class]
			local classColorString = format("ff%.2x%.2x%.2x", classColor.r * 255, classColor.g * 255, classColor.b * 255)
			local specName

			if (primaryTalentTree) then
				_, specName = GetTalentTabInfo(primaryTalentTree);
			end

			if (specName and specName ~= "") then
				CharacterLevelText:SetFormattedText(PLAYER_LEVEL, UnitLevel("player"), classColorString, specName, classDisplayName);
			else
				CharacterLevelText:SetFormattedText(PLAYER_LEVEL_NO_SPEC, UnitLevel("player"), classColorString, classDisplayName);
			end
		end

		hooksecurefunc("QuestInfo_Display", newquestcolor)
		hooksecurefunc("GossipFrameUpdate", newgossipcolor)
		hooksecurefunc("SpellButton_UpdateButton", newspellbookcolor)
		hooksecurefunc("FormatProfession", newprofcolor)
		hooksecurefunc("UpdateProfessionButton", newprofbuttoncolor)

		-- [[ Change positions ]]

		ChatConfigFrameDefaultButton:SetWidth(125)
		ChatConfigFrameDefaultButton:ClearAllPoints()
		ChatConfigFrameDefaultButton:SetPoint("TOP", ChatConfigCategoryFrame, "BOTTOM", 0, -4)
		ChatConfigFrameOkayButton:ClearAllPoints()
		ChatConfigFrameOkayButton:SetPoint("TOPRIGHT", ChatConfigBackgroundFrame, "BOTTOMRIGHT", 0, -4)

		_G["VideoOptionsFrameCancel"]:ClearAllPoints()
		_G["VideoOptionsFrameCancel"]:SetPoint("RIGHT",_G["VideoOptionsFrameApply"],"LEFT",-4,0)		 
		_G["VideoOptionsFrameOkay"]:ClearAllPoints()
		_G["VideoOptionsFrameOkay"]:SetPoint("RIGHT",_G["VideoOptionsFrameCancel"],"LEFT",-4,0)	
		_G["AudioOptionsFrameOkay"]:ClearAllPoints()
		_G["AudioOptionsFrameOkay"]:SetPoint("RIGHT",_G["AudioOptionsFrameCancel"],"LEFT",-4,0)		 	 
		_G["InterfaceOptionsFrameOkay"]:ClearAllPoints()
		_G["InterfaceOptionsFrameOkay"]:SetPoint("RIGHT",_G["InterfaceOptionsFrameCancel"],"LEFT", -4,0)

		GearManagerDialog:ClearAllPoints()
		GearManagerDialog:SetPoint("TOPLEFT", PaperDollFrame, "TOPRIGHT", 10, 0)

		QuestLogFrameShowMapButton:Hide()
		QuestLogFrameShowMapButton.Show = Aurora.dummy

		local questlogcontrolpanel = function()
			local parent
			if QuestLogFrame:IsShown() then
				parent = QuestLogFrame
				QuestLogControlPanel:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", 9, 6)
			elseif QuestLogDetailFrame:IsShown() then
				parent = QuestLogDetailFrame
				QuestLogControlPanel:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", 9, 0)
			end
		end

		hooksecurefunc("QuestLogControlPanel_UpdatePosition", questlogcontrolpanel)

		QuestLogFramePushQuestButton:ClearAllPoints()
		QuestLogFramePushQuestButton:SetPoint("LEFT", QuestLogFrameAbandonButton, "RIGHT", 1, 0)
		QuestLogFramePushQuestButton:SetWidth(100)
		QuestLogFrameTrackButton:ClearAllPoints()
		QuestLogFrameTrackButton:SetPoint("LEFT", QuestLogFramePushQuestButton, "RIGHT", 1, 0)

		FriendsFrameStatusDropDown:ClearAllPoints()
		FriendsFrameStatusDropDown:SetPoint("TOPLEFT", FriendsFrame, "TOPLEFT", 10, -40)
		FriendsFrameCloseButton:ClearAllPoints()
		FriendsFrameCloseButton:SetPoint("LEFT", FriendsFrameBroadcastInput, "RIGHT", 20, 0)

		RaidFrameConvertToRaidButton:ClearAllPoints()
		RaidFrameConvertToRaidButton:SetPoint("TOPLEFT", FriendsFrame, "TOPLEFT", 30, -44)
		RaidFrameRaidInfoButton:ClearAllPoints()
		RaidFrameRaidInfoButton:SetPoint("TOPRIGHT", FriendsFrame, "TOPRIGHT", -70, -44)

		TaxiFrameCloseButton:ClearAllPoints()
		TaxiFrameCloseButton:SetPoint("TOPRIGHT", TaxiRouteMap, "TOPRIGHT")

		local a1, p, a2, x, y = ReputationDetailFrame:GetPoint()
		ReputationDetailFrame:SetPoint(a1, p, a2, x + 10, y)

		-- [[ Tabs ]]

		for i = 1, 5 do
			Aurora.CreateTab(_G["SpellBookFrameTabButton"..i])
		end

		for i = 1, 4 do
			Aurora.CreateTab(_G["FriendsFrameTab"..i])
			if _G["CharacterFrameTab"..i] then
				Aurora.CreateTab(_G["CharacterFrameTab"..i])
			end
		end

		for i = 1, 3 do
			Aurora.CreateTab(_G["PVPFrameTab"..i])
			Aurora.CreateTab(_G["WorldStateScoreFrameTab"..i])
		end

		for i = 1, 2 do
			Aurora.CreateTab(_G["LFRParentFrameTab"..i])
			Aurora.CreateTab(_G["MerchantFrameTab"..i])
			Aurora.CreateTab(_G["MailFrameTab"..i])
		end

		-- [[ Buttons ]]

		for i = 1, 2 do
			for j = 1, 2 do
				Aurora.Reskin(_G["StaticPopup"..i.."Button"..j])
			end
		end

		local buttons = {"VideoOptionsFrameOkay", "VideoOptionsFrameCancel", "VideoOptionsFrameDefaults", "VideoOptionsFrameApply", "AudioOptionsFrameOkay", "AudioOptionsFrameCancel", "AudioOptionsFrameDefaults", "InterfaceOptionsFrameDefaults", "InterfaceOptionsFrameOkay", "InterfaceOptionsFrameCancel", "ChatConfigFrameOkayButton", "ChatConfigFrameDefaultButton", "DressUpFrameCancelButton", "DressUpFrameResetButton", "WhoFrameWhoButton", "WhoFrameAddFriendButton", "WhoFrameGroupInviteButton", "GearManagerDialogDeleteSet", "GearManagerDialogEquipSet", "GearManagerDialogSaveSet", "SendMailMailButton", "SendMailCancelButton", "OpenMailReplyButton", "OpenMailDeleteButton", "OpenMailCancelButton", "OpenMailReportSpamButton", "aMailButton", "QuestLogFrameAbandonButton", "QuestLogFramePushQuestButton", "QuestLogFrameTrackButton", "QuestLogFrameCancelButton", "QuestFrameAcceptButton", "QuestFrameDeclineButton", "QuestFrameCompleteQuestButton", "QuestFrameCompleteButton", "QuestFrameGoodbyeButton", "GossipFrameGreetingGoodbyeButton", "QuestFrameGreetingGoodbyeButton", "ChannelFrameNewButton", "RaidFrameRaidInfoButton", "RaidFrameConvertToRaidButton", "TradeFrameTradeButton", "TradeFrameCancelButton", "GearManagerDialogPopupOkay", "GearManagerDialogPopupCancel", "StackSplitOkayButton", "StackSplitCancelButton", "TabardFrameAcceptButton", "TabardFrameCancelButton"}
		for i = 1, getn(buttons) do
		local reskinbutton = _G[buttons[i]]
			if reskinbutton then
				Aurora.Reskin(reskinbutton)
			end
		end

		local alphabuttons = {"GameMenuButtonOptions", "GameMenuButtonSoundOptions", "GameMenuButtonUIOptions", "GameMenuButtonKeybindings", "GameMenuButtonMacros", "GameMenuButtonAddOns", "GameMenuButtonLogout", "GameMenuButtonQuit", "GameMenuButtonContinue", "GameMenuButtonMacOptions", "FriendsFrameAddFriendButton", "FriendsFrameSendMessageButton", "LFDQueueFrameFindGroupButton", "LFDQueueFrameCancelButton", "LFRQueueFrameFindGroupButton", "LFRQueueFrameAcceptCommentButton", "PVPFrameLeftButton", "PVPHonorFrameWarGameButton", "PVPFrameRightButton", "RaidFrameNotInRaidRaidBrowserButton", "WorldStateScoreFrameLeaveButton", "SpellBookCompanionSummonButton", "AddFriendEntryFrameAcceptButton", "AddFriendEntryFrameCancelButton", "FriendsFriendsSendRequestButton", "FriendsFriendsCloseButton", "ColorPickerOkayButton", "ColorPickerCancelButton", "FriendsFrameIgnorePlayerButton", "FriendsFrameUnsquelchButton", "LFDDungeonReadyDialogEnterDungeonButton", "LFDDungeonReadyDialogLeaveQueueButton", "LFRBrowseFrameSendMessageButton", "LFRBrowseFrameInviteButton", "LFRBrowseFrameRefreshButton", "LFDRoleCheckPopupAcceptButton", "LFDRoleCheckPopupDeclineButton", "GuildInviteFrameJoinButton", "GuildInviteFrameDeclineButton", "FriendsFramePendingButton1AcceptButton", "FriendsFramePendingButton1DeclineButton"}
		for i = 1, getn(alphabuttons) do
		local button = _G[alphabuttons[i]]
			if button then
				Aurora.Reskin(button)
				_G[alphabuttons[i].."Left"]:SetAlpha(0)
				_G[alphabuttons[i].."Middle"]:SetAlpha(0)
				_G[alphabuttons[i].."Right"]:SetAlpha(0)
			end
		end

	-- [[ Load on Demand Addons ]]

	elseif addon == "Blizzard_ArchaeologyUI" then
		Aurora.CreateBD(ArchaeologyFrame)
		Aurora.CreateSD(ArchaeologyFrame)
		Aurora.Reskin(ArchaeologyFrameArtifactPageSolveFrameSolveButton)
		_G["ArchaeologyFrameArtifactPageSolveFrameSolveButton".."Left"]:SetAlpha(0)
		_G["ArchaeologyFrameArtifactPageSolveFrameSolveButton".."Middle"]:SetAlpha(0)
		_G["ArchaeologyFrameArtifactPageSolveFrameSolveButton".."Right"]:SetAlpha(0)
		select(3, ArchaeologyFrame:GetRegions()):Hide()
	elseif addon == "Blizzard_AuctionUI" then
		local AuctionBD = CreateFrame("Frame", nil, AuctionFrame)
		AuctionBD:SetPoint("TOPLEFT", 2, -10)
		AuctionBD:SetPoint("BOTTOMRIGHT", 0, 10)
		AuctionBD:SetFrameStrata("MEDIUM")
		Aurora.CreateBD(AuctionBD)
		Aurora.CreateSD(AuctionBD)
		Aurora.CreateBD(AuctionProgressFrame)
		Aurora.CreateSD(AuctionProgressFrame)
		AuctionDressUpFrame:ClearAllPoints()
		AuctionDressUpFrame:SetPoint("LEFT", AuctionFrame, "RIGHT", 10, 0)
		Aurora.CreateBD(AuctionDressUpFrame)
		Aurora.CreateSD(AuctionDressUpFrame)

		local ABBD = CreateFrame("Frame", nil, AuctionProgressBar)
		if IsAddOnLoaded("Tukui") and tukuiskin == true then
			ABBD:SetPoint("TOPLEFT", -2, 2)
			ABBD:SetPoint("BOTTOMRIGHT", 2, -2)
		else
			ABBD:SetPoint("TOPLEFT", -1, 1)
			ABBD:SetPoint("BOTTOMRIGHT", 1, -1)
		end
		ABBD:SetFrameLevel(AuctionProgressBar:GetFrameLevel()-1)
		Aurora.CreateBD(ABBD, .25)

		select(1, AuctionFrame:GetRegions()):Hide()
		for i = 1, 4 do
			select(i, AuctionProgressFrame:GetRegions()):Hide()
		end
		select(2, AuctionProgressBar:GetRegions()):Hide()
		for i = 1, 4 do
			select(i, AuctionDressUpFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			Aurora.CreateTab(_G["AuctionFrameTab"..i])
		end
		local abuttons = {"BrowseBidButton", "BrowseBuyoutButton", "BrowseCloseButton", "BrowseSearchButton", "BrowseResetButton", "BidBidButton", "BidBuyoutButton", "BidCloseButton", "AuctionsCloseButton", "AuctionDressUpFrameResetButton"}
		for i = 1, getn(abuttons) do
			local reskinbutton = _G[abuttons[i]]
			if reskinbutton then
				Aurora.Reskin(reskinbutton)
			end
		end
		local apbuttons = {"AuctionsCancelAuctionButton", "AuctionsCreateAuctionButton", "AuctionsNumStacksMaxButton", "AuctionsStackSizeMaxButton"}
		for i = 1, getn(apbuttons) do
			local reskinbutton = _G[apbuttons[i]]
			if reskinbutton then
				Aurora.Reskin(reskinbutton)
				_G[apbuttons[i].."Left"]:SetAlpha(0)
				_G[apbuttons[i].."Middle"]:SetAlpha(0)
				_G[apbuttons[i].."Right"]:SetAlpha(0)
			end
		end
		BrowseBuyoutButton:ClearAllPoints()
		BrowseBuyoutButton:SetPoint("RIGHT", BrowseCloseButton, "LEFT", -1, 0)
		BrowseBidButton:ClearAllPoints()
		BrowseBidButton:SetPoint("RIGHT", BrowseBuyoutButton, "LEFT", -1, 0)
		BidBuyoutButton:ClearAllPoints()
		BidBuyoutButton:SetPoint("RIGHT", BidCloseButton, "LEFT", -1, 0)
		BidBidButton:ClearAllPoints()
		BidBidButton:SetPoint("RIGHT", BidBuyoutButton, "LEFT", -1, 0)
		AuctionsCancelAuctionButton:ClearAllPoints()
		AuctionsCancelAuctionButton:SetPoint("RIGHT", AuctionsCloseButton, "LEFT", -1, 0)
	elseif addon == "Blizzard_AchievementUI" then
		Aurora.CreateBD(AchievementFrame)
		Aurora.CreateSD(AchievementFrame)
		for i = 1, 17 do
			select(i, AchievementFrame:GetRegions()):Hide()
		end
		select(1, AchievementFrameSummary:GetRegions()):Hide()
		select(1, AchievementFrameHeader:GetRegions()):Hide()
		select(2, AchievementFrameHeader:GetRegions()):Hide()
		select(3, AchievementFrameHeader:GetRegions()):Hide()
		select(4, AchievementFrameHeader:GetRegions()):Hide()
		AchievementFrameHeader:ClearAllPoints()
		AchievementFrameHeader:SetPoint("TOP", AchievementFrameSummary, "TOP", -24, 60)
		for i = 1, 3 do
			if _G["AchievementFrameTab"..i] then
				for j = 1, 6 do
					select(j, _G["AchievementFrameTab"..i]:GetRegions()):Hide()
					select(j, _G["AchievementFrameTab"..i]:GetRegions()).Show = Aurora.dummy
				end
				local sd = CreateFrame("Frame", nil, _G["AchievementFrameTab"..i])
				sd:SetPoint("TOPLEFT", 6, -4)
				sd:SetPoint("BOTTOMRIGHT", -6, -2)
				sd:SetFrameStrata("LOW")
				if IsAddOnLoaded("Tukui") and tukuiskin == true then
					sd:SetBackdrop({
						bgFile = Aurora.backdrop,
						edgeFile = Aurora.backdrop,
						tile = false, tileSize = 0, edgeSize = 1, 
	 					insets = { left = -1, right = -1, top = -1, bottom = -1}
					})
					sd:SetBackdropColor(unpack(TukuiCF["media"].backdropcolor))
					sd:SetBackdropBorderColor(unpack(TukuiCF["media"].bordercolor))
				else
					sd:SetBackdrop({
						bgFile = Aurora.backdrop,
						edgeFile = Aurora.glow,
						edgeSize = 5,
						insets = { left = 5, right = 5, top = 5, bottom = 5 },
					})
					sd:SetBackdropColor(0, 0, 0, .5)
					sd:SetBackdropBorderColor(0, 0, 0)
				end
			end
		end
	elseif addon == "Blizzard_BindingUI" then
		local BindingBD = CreateFrame("Frame", nil, KeyBindingFrame)
		BindingBD:SetPoint("TOPLEFT", 2, 0)
		BindingBD:SetPoint("BOTTOMRIGHT", -38, 10)
		BindingBD:SetFrameStrata("BACKGROUND")
		Aurora.CreateBD(BindingBD)
		Aurora.CreateSD(BindingBD)
		KeyBindingFrameHeader:SetTexture("")
	elseif addon == "Blizzard_Calendar" then
		for i = 1, 15 do
			if i ~= 10 and i ~= 11 and i ~= 12 and i ~= 13 and i ~= 14 then select(i, CalendarViewEventFrame:GetRegions()):Hide() end
		end
		for i = 1, 9 do
			select(i, CalendarViewHolidayFrame:GetRegions()):Hide()
			select(i, CalendarViewRaidFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			select(i, CalendarViewEventTitleFrame:GetRegions()):Hide()
			select(i, CalendarViewHolidayTitleFrame:GetRegions()):Hide()
			select(i, CalendarViewRaidTitleFrame:GetRegions()):Hide()
		end
		select(1, CalendarViewEventInviteListSection:GetRegions()):Hide()
		select(1, CalendarViewEventInviteList:GetRegions()):Hide()
		select(1, CalendarViewEventDescriptionContainer:GetRegions()):Hide()
		select(5, CalendarViewEventCloseButton:GetRegions()):Hide()
		select(5, CalendarViewHolidayCloseButton:GetRegions()):Hide()
		select(5, CalendarViewRaidCloseButton:GetRegions()):Hide()
		local CalBD = CreateFrame("Frame", nil, CalendarFrame)
		CalBD:SetPoint("TOPLEFT", 11, 0)
		CalBD:SetPoint("BOTTOMRIGHT", -9, 3)
		CalBD:SetFrameStrata("MEDIUM")
		Aurora.CreateBD(CalBD)
		Aurora.CreateSD(CalBD)
		Aurora.CreateBD(CalendarViewEventFrame)
		Aurora.CreateSD(CalendarViewEventFrame)
		Aurora.CreateBD(CalendarViewHolidayFrame)
		Aurora.CreateSD(CalendarViewHolidayFrame)
		Aurora.CreateBD(CalendarViewRaidFrame)
		Aurora.CreateSD(CalendarViewRaidFrame)
		Aurora.CreateBD(CalendarViewEventInviteList, .25)
		Aurora.CreateBD(CalendarViewEventDescriptionContainer, .25)
		for i = 1, 42 do
			Aurora.CreateBD(_G["CalendarDayButton"..i], 0)
		end
		local cbuttons = { "CalendarViewEventAcceptButton", "CalendarViewEventTentativeButton", "CalendarViewEventDeclineButton", "CalendarViewEventRemoveButton" }
		for i = 1, getn(cbuttons) do
		local cbutton = _G[cbuttons[i]]
			if cbutton then
				Aurora.Reskin(cbutton)
				_G[cbuttons[i].."Left"]:SetAlpha(0)
				_G[cbuttons[i].."Middle"]:SetAlpha(0)
				_G[cbuttons[i].."Right"]:SetAlpha(0)
			end
		end
		CalendarCloseButton:ClearAllPoints()
		CalendarCloseButton:SetPoint("TOPRIGHT", CalBD, "TOPRIGHT")
	elseif addon == "Blizzard_GlyphUI" then
		select(1, GlyphFrame:GetRegions()):Hide()
	elseif addon == "Blizzard_GuildBankUI" then
		Aurora.CreateBD(GuildBankFrame)
		Aurora.CreateSD(GuildBankFrame)
		for i = 1, 4 do
			Aurora.CreateTab(_G["GuildBankFrameTab"..i])
		end
		Aurora.Reskin(GuildBankFrameWithdrawButton)
		Aurora.Reskin(GuildBankFrameDepositButton)
	elseif addon == "Blizzard_GuildUI" then
		Aurora.CreateBD(GuildFrame)
		Aurora.CreateSD(GuildFrame)
		Aurora.CreateBD(GuildMemberDetailFrame)
		Aurora.CreateSD(GuildMemberDetailFrame)
		Aurora.CreateBD(GuildMemberNoteBackground, .25)
		Aurora.CreateBD(GuildMemberOfficerNoteBackground, .25)
		Aurora.CreateBD(GuildLogFrame)
		Aurora.CreateSD(GuildLogFrame)
		Aurora.CreateBD(GuildLogContainer, .25)
		Aurora.CreateBD(GuildNewsFiltersFrame)
		Aurora.CreateSD(GuildNewsFiltersFrame)
		for i = 1, 5 do
			Aurora.CreateTab(_G["GuildFrameTab"..i])
		end
		select(18, GuildFrame:GetRegions()):Hide()
		select(21, GuildFrame:GetRegions()):Hide()
		select(22, GuildFrame:GetRegions()):Hide()
		select(5, GuildInfoFrame:GetRegions()):Hide()
		select(1, GuildLevelFrame:GetRegions()):Hide()
		select(11, GuildMemberDetailFrame:GetRegions()):Hide()
		select(12, GuildMemberDetailFrame:GetRegions()):Hide()
		for i = 1, 9 do
			select(i, GuildLogFrame:GetRegions()):Hide()
		end
		select(2, GuildNewPerksFrame:GetRegions()):Hide()
		select(3, GuildNewPerksFrame:GetRegions()):Hide()
		select(1, GuildAllPerksFrame:GetRegions()):Hide()
		select(1, GuildNewsFrame:GetRegions()):Hide()
		select(1, GuildRewardsFrame:GetRegions()):Hide()
		for i = 1, 9 do
			select(i, GuildNewsFiltersFrame:GetRegions()):Hide()
		end
		GuildLevelFrame:ClearAllPoints()
		GuildLevelFrame:SetPoint("TOPLEFT", GuildFrame, "TOPLEFT", 8, -8)
		GuildNewsFiltersFrame:ClearAllPoints()
		GuildNewsFiltersFrame:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 10, -10)
		GuildMemberDetailFrame:ClearAllPoints()
		GuildMemberDetailFrame:SetPoint("TOPLEFT", GuildFrame, "TOPRIGHT", 10, -10)
		GuildLevelFrame:SetAlpha(0)
		Aurora.Reskin(GuildMemberGroupInviteButton)
		Aurora.Reskin(GuildMemberRemoveButton)
		-- reskin(GuildLogFrameCloseButton) two buttons with same name :(
		local gbuttons = {"GuildAddMemberButton", "GuildViewLogButton", "GuildControlButton"}
		for i = 1, getn(gbuttons) do
		local gbutton = _G[gbuttons[i]]
			if gbutton then
				Aurora.Reskin(gbutton)
				_G[gbuttons[i].."Left"]:SetAlpha(0)
				_G[gbuttons[i].."Middle"]:SetAlpha(0)
				_G[gbuttons[i].."Right"]:SetAlpha(0)
			end
		end
	elseif addon == "Blizzard_InspectUI" then
		Aurora.CreateBD(InspectFrame)
		Aurora.CreateSD(InspectFrame)

		local slots = {
			"Head", "Neck", "Shoulder", "Shirt", "Chest", "Waist", "Legs", "Feet", "Wrist",
			"Hands", "Finger0", "Finger1", "Trinket0", "Trinket1", "Back", "MainHand",
			"SecondaryHand", "Ranged", "Tabard",
		}

		for i = 1, getn(slots) do
			local bd = CreateFrame("Frame", nil, _G["Inspect"..slots[i].."Slot"])
			bd:SetPoint("TOPLEFT", -1, 1)
			bd:SetPoint("BOTTOMRIGHT", 1, -1)
			Aurora.CreateBD(bd)
			bd:SetBackdropColor(0, 0, 0, 0)
			_G["Inspect"..slots[i].."Slot"]:SetNormalTexture("")
			select(1, _G["Inspect"..slots[i].."Slot"]:GetRegions()):SetTexCoord(.08, .92, .08, .92)
		end

		for i = 1, 4 do
			Aurora.CreateTab(_G["InspectFrameTab"..i])
		end
		select(3, InspectFrame:GetRegions()):Hide()
		select(1, InspectGuildFrame:GetRegions()):Hide()
		for i = 1, 5 do
			select(i, InspectModelFrame:GetRegions()):Hide()
		end
		for i = 1, 4 do
			select(i, InspectTalentFrame:GetRegions()):Hide()
		end
		for i = 1, 3 do
			for j = 1, 6 do
				select(j, _G["InspectTalentFrameTab"..i]:GetRegions()):Hide()
				select(j, _G["InspectTalentFrameTab"..i]:GetRegions()).Show = Aurora.dummy
			end
		end
	elseif addon == "Blizzard_ItemSocketingUI" then
		local SocketBD = CreateFrame("Frame", nil, ItemSocketingFrame)
		SocketBD:SetPoint("TOPLEFT", 12, -8)
		SocketBD:SetPoint("BOTTOMRIGHT", -2, 24)
		SocketBD:SetFrameStrata("LOW")
		Aurora.CreateBD(SocketBD)
		Aurora.CreateSD(SocketBD)
		select(1, ItemSocketingFrame:GetRegions()):Hide()
		Aurora.Reskin(ItemSocketingSocketButton)
		_G["ItemSocketingSocketButton".."Left"]:SetAlpha(0)
		_G["ItemSocketingSocketButton".."Middle"]:SetAlpha(0)
		_G["ItemSocketingSocketButton".."Right"]:SetAlpha(0)
		ItemSocketingSocketButton:ClearAllPoints()
		ItemSocketingSocketButton:SetPoint("BOTTOMRIGHT", ItemSocketingFrame, "BOTTOMRIGHT", -10, 28)
	elseif addon == "Blizzard_MacroUI" then
		local MacroBD = CreateFrame("Frame", nil, MacroFrame)
		MacroBD:SetPoint("TOPLEFT", 12, -10)
		MacroBD:SetPoint("BOTTOMRIGHT", -33, 68)
		MacroBD:SetFrameStrata("LOW")
		Aurora.CreateBD(MacroBD)
		Aurora.CreateSD(MacroBD)
		Aurora.CreateBD(MacroFrameTextBackground, .25)
		Aurora.CreateBD(MacroPopupFrame)
		Aurora.CreateSD(MacroPopupFrame)
		for i = 1, 6 do
			select(i, MacroFrameTab1:GetRegions()):Hide()
			select(i, MacroFrameTab2:GetRegions()):Hide()
			select(i, MacroFrameTab1:GetRegions()).Show = Aurora.dummy
			select(i, MacroFrameTab2:GetRegions()).Show = Aurora.dummy
		end
		for i = 1, 8 do
			if i ~= 6 then select(i, MacroFrame:GetRegions()):Hide() end
		end
		for i = 1, 5 do
			select(i, MacroPopupFrame:GetRegions()):Hide()
		end
		Aurora.Reskin(MacroDeleteButton)
		Aurora.Reskin(MacroNewButton)
		Aurora.Reskin(MacroExitButton)
		Aurora.Reskin(MacroEditButton)
		Aurora.Reskin(MacroPopupOkayButton)
		Aurora.Reskin(MacroPopupCancelButton)
		MacroPopupFrame:ClearAllPoints()
		MacroPopupFrame:SetPoint("LEFT", MacroFrame, "RIGHT", -14, 16)
	elseif addon == "Blizzard_RaidUI" then
		for i = 1, 5 do
			if i ~= 3 and i ~= 2 then select(i, CompactRaidFrameManagerDisplayFrame:GetRegions()):Hide() end
		end
		for i = 1, 8 do
			select(i, CompactRaidFrameManager:GetRegions()):Hide()
		end
		Aurora.CreateBD(CompactRaidFrameManagerDisplayFrame)
		Aurora.CreateSD(CompactRaidFrameManagerDisplayFrame)
		Aurora.Reskin(CompactRaidFrameManagerToggleButton)
		Aurora.Reskin(RaidFrameRaidBrowserButton)
		local rbuttons = {"CompactRaidFrameManagerDisplayFrameFilterRoleTank", "CompactRaidFrameManagerDisplayFrameFilterRoleHealer", "CompactRaidFrameManagerDisplayFrameFilterRoleDamager", "CompactRaidFrameManagerDisplayFrameFilterGroup1", "CompactRaidFrameManagerDisplayFrameFilterGroup2", "CompactRaidFrameManagerDisplayFrameFilterGroup3", "CompactRaidFrameManagerDisplayFrameFilterGroup4", "CompactRaidFrameManagerDisplayFrameFilterGroup5", "CompactRaidFrameManagerDisplayFrameFilterGroup6", "CompactRaidFrameManagerDisplayFrameFilterGroup7", "CompactRaidFrameManagerDisplayFrameFilterGroup8", "CompactRaidFrameManagerDisplayFrameLockedModeToggle", "CompactRaidFrameManagerDisplayFrameHiddenModeToggle", "CompactRaidFrameManagerDisplayFrameLeaderOptionsInitiateRolePoll", "CompactRaidFrameManagerDisplayFrameLeaderOptionsInitiateReadyCheck", "CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton"}
		for i = 1, getn(rbuttons) do
			local rbutton = _G[rbuttons[i]]
			if rbutton then
				Aurora.Reskin(rbutton)
				_G[rbuttons[i].."Left"]:SetAlpha(0)
				_G[rbuttons[i].."Middle"]:SetAlpha(0)
				_G[rbuttons[i].."Right"]:SetAlpha(0)
			end
		end
		CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton:SetText("Mark") -- because the texture is hidden, don't want an empty button
		CompactRaidFrameManagerDisplayFrameOptionsButton:Hide()
		local a1, p, a2, x, y = CompactRaidFrameManagerToggleButton:GetPoint()
		CompactRaidFrameManagerToggleButton:SetPoint(a1, p, a2, x + 5, y)
	elseif addon == "Blizzard_ReforgingUI" then
		Aurora.CreateBD(ReforgingFrame)
		Aurora.CreateSD(ReforgingFrame)
		select(3, ReforgingFrame:GetRegions()):Hide()
		Aurora.Reskin(ReforgingFrameRestoreButton)
		Aurora.Reskin(ReforgingFrameReforgeButton)
		_G["ReforgingFrameRestoreButton".."Left"]:SetAlpha(0)
		_G["ReforgingFrameRestoreButton".."Middle"]:SetAlpha(0)
		_G["ReforgingFrameRestoreButton".."Right"]:SetAlpha(0)
		_G["ReforgingFrameReforgeButton".."Left"]:SetAlpha(0)
		_G["ReforgingFrameReforgeButton".."Middle"]:SetAlpha(0)
		_G["ReforgingFrameReforgeButton".."Right"]:SetAlpha(0)
	elseif addon == "Blizzard_TalentUI" then
		Aurora.CreateBD(PlayerTalentFrame)
		Aurora.CreateSD(PlayerTalentFrame)
		local talentbuttons = { "PlayerTalentFrameToggleSummariesButton", "PlayerTalentFrameLearnButton", "PlayerTalentFrameResetButton" }
		for i = 1, getn(talentbuttons) do
		local reskinbutton = _G[talentbuttons[i]]
			if reskinbutton then
				Aurora.Reskin(reskinbutton)
				_G[talentbuttons[i].."Left"]:SetAlpha(0)
				_G[talentbuttons[i].."Middle"]:SetAlpha(0)
				_G[talentbuttons[i].."Right"]:SetAlpha(0)
			end
		end	
		select(3, PlayerTalentFrame:GetRegions()):Hide()
		for i = 1, 3 do
			if _G["PlayerTalentFrameTab"..i] then
				Aurora.CreateTab(_G["PlayerTalentFrameTab"..i])
			end
		end
	elseif addon == "Blizzard_TradeSkillUI" then
		Aurora.CreateBD(TradeSkillFrame)
		Aurora.CreateSD(TradeSkillFrame)
		select(3, TradeSkillFrame:GetRegions()):Hide()
		select(3, TradeSkillFrame:GetRegions()).Show = Aurora.dummy
		select(21, TradeSkillFrame:GetRegions()):Hide()
		select(22, TradeSkillFrame:GetRegions()):Hide()
		local tradeskillbuttons = {"TradeSkillCreateButton", "TradeSkillCreateAllButton", "TradeSkillCancelButton"}
		for i = 1, getn(tradeskillbuttons) do
		local button = _G[tradeskillbuttons[i]]
			if button then
				Aurora.Reskin(button)
				_G[tradeskillbuttons[i].."Left"]:SetAlpha(0)
				_G[tradeskillbuttons[i].."Middle"]:SetAlpha(0)
				_G[tradeskillbuttons[i].."Right"]:SetAlpha(0)
			end
		end
	elseif addon == "Blizzard_TrainerUI" then
		Aurora.CreateBD(ClassTrainerFrame)
		Aurora.CreateSD(ClassTrainerFrame)
		select(3, ClassTrainerFrame:GetRegions()):Hide()
		select(19, ClassTrainerFrame:GetRegions()):Hide()
		Aurora.Reskin(ClassTrainerTrainButton)
		_G["ClassTrainerTrainButton".."Left"]:SetAlpha(0)
		_G["ClassTrainerTrainButton".."Middle"]:SetAlpha(0)
		_G["ClassTrainerTrainButton".."Right"]:SetAlpha(0)
	end

	-- [[ Mac Options ]]

	if IsMacClient() then
		-- Skin main frame and reposition the header
		Aurora.CreateBD(MacOptionsFrame)
		MacOptionsFrameHeader:SetTexture("")
		MacOptionsFrameHeader:ClearAllPoints()
		MacOptionsFrameHeader:SetPoint("TOP", MacOptionsFrame, 0, 0)
 
		--Skin internal frames
		Aurora.CreateBD(MacOptionsFrameMovieRecording, .25)
		Aurora.CreateBD(MacOptionsITunesRemote, .25)
 
		--Skin buttons
		Aurora.Reskin(_G["MacOptionsFrameCancel"])
		Aurora.Reskin(_G["MacOptionsFrameOkay"])
		Aurora.Reskin(_G["MacOptionsFrameDefaults"])

		local stupidbuttons = {"MacOptionsButtonKeybindings", "MacOptionsButtonCompress"}
		for i = 1, getn(stupidbuttons) do
		local button = _G[stupidbuttons[i]]
			if button then
				Aurora.Reskin(button)
				_G[stupidbuttons[i].."Left"]:SetAlpha(0)
				_G[stupidbuttons[i].."Middle"]:SetAlpha(0)
				_G[stupidbuttons[i].."Right"]:SetAlpha(0)
			end
		end
 
		--Reposition and resize buttons
		_G["MacOptionsButtonCompress"]:SetWidth(136)
 
		_G["MacOptionsFrameCancel"]:SetWidth(96)
		_G["MacOptionsFrameCancel"]:SetHeight(22)
		_G["MacOptionsFrameCancel"]:ClearAllPoints()
		_G["MacOptionsFrameCancel"]:SetPoint("LEFT", _G["MacOptionsButtonKeybindings"], "RIGHT", 107, 0)
 
		_G["MacOptionsFrameOkay"]:SetWidth(96)
		_G["MacOptionsFrameOkay"]:SetHeight(22)
		_G["MacOptionsFrameOkay"]:ClearAllPoints()
		_G["MacOptionsFrameOkay"]:SetPoint("LEFT", _G["MacOptionsButtonKeybindings"], "RIGHT", 5, 0)
 
		_G["MacOptionsButtonKeybindings"]:SetWidth(96)
		_G["MacOptionsButtonKeybindings"]:SetHeight(22)
		_G["MacOptionsButtonKeybindings"]:ClearAllPoints()
		_G["MacOptionsButtonKeybindings"]:SetPoint("LEFT", _G["MacOptionsFrameDefaults"], "RIGHT", 5, 0)
 
		_G["MacOptionsFrameDefaults"]:SetWidth(96)
		_G["MacOptionsFrameDefaults"]:SetHeight(22)
 
	end
end)