local PugLax = _G.PugLax

local reverseMark = {	
	[1]="star",
	[2]="circle",
	[3]="diamond",
	[4]="triangle",
	[5]="moon",
	[6]="square",
	[7]="cross",
	[8]="skull",
}

function PugLax:CreateRaidIcon(t,i)
	asgn = PugLax.Marks[reverseMark[i]]["assignment"]
	
	targetType = UnitCreatureType("target")
	
	if (not t.subTex) then
		t.subTex = t:GetParent():CreateTexture("PugLaxSRTIRadialOverlay"..i,"HIGHLIGHT");
		t.subTex:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
		SetRaidTargetIconTexture(t.subTex,i);
		
		local radians = (0.375 - i/8) * 360;
		t.subTex:SetPoint("CENTER", t:GetParent(), "CENTER", 36*cos(radians) + 6, 36*sin(radians) - 6 );
		t.subTex:SetAlpha(0.8);
		t.subTex:SetWidth(12);
		t.subTex:SetHeight(12);
	end
	
	if (asgn) then
		t:SetTexCoord(0,1,0,1);
		local spellName, spellRank, spellIcon = GetSpellInfo(PugLax.ccData[asgn["ccKey"]]["spellID"]);
		t:SetTexture(spellIcon);
		
		if (t.subTex) then
			t.subTex:Show()
		end
		
	else
		t:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
		SetRaidTargetIconTexture(t,i);
		
		if (t.subTex) then
			t.subTex:Hide()
		end
	end
end

-- For mhennings of WoWInterface.com

function PugLax:GetAssignment(i)
	local spellID, playerName, assignment
	assignment = PugLax.Marks[reverseMark[i]]["assignment"]
	if assignment then
		spellID = PugLax.ccData[assignment["ccKey"]]["spellID"];
		playerName = assignment["playername"];
	end
	
	return spellID, playerName
end

function PugLax:CreateAssignmentIcon(t,i)
	local assignment = PugLax.Marks[reverseMark[i]]["assignment"]
	if assignment then
		
		targetType = UnitCreatureType("target")
		
		if (asgn) then
			t:SetTexCoord(0,1,0,1);
			local spellIcon
			_, _, spellIcon = GetSpellInfo(PugLax.ccData[asgn["ccKey"]]["spellID"]);
			t:SetTexture(spellIcon);
			t:Show()
		else
			t:Hide()
		end
		
	end
end